*
*  Copyright (C) 2000-2005 Samuel Thibault <samuel.thibault@ens-lyon.org>
*
* This program is free software ; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation ; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY ; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with the program ; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* applet/usinagaz.s
*
* 16/02/03
*
* Applet frame for 38/39/40 version
*
* from JYA's skeleton
*

ASSEMBLE
	Dir_Head 8,Usinagaz,6EC
RPL

{
 topic_CAPLET
 view01_CAPLET
 view23_CAPLET
 view45_CAPLET
 xREADNOTE
 xREADPICT
}

* do not modify !
INCLUDE applet/sharedvar.h	( Include all the variables needed by the aplet structure )

ASSEMBLE 
	Vfield  L34,IntTable
	CON(5)	=DOHSTR
	REL(5)  endLink
	Link	_Main
	Link	_Entry
	Link	_Disp
	Link	_Exit
	Link	_MainMenu
	Link	_Setup
	Link	_On
	Link	_Off
	Link	_Idle
endLink
RPL

DEFINE Main		INT_00
DEFINE Entry		INT_01
DEFINE Disp		INT_02
DEFINE Exit		INT_03
DEFINE MainMenu		INT_04
DEFINE Setup		INT_05
DEFINE On		INT_06
DEFINE Off		INT_07
DEFINE Idle		INT_08
*	Use INT_10..INT_1F and INT_NN w/ care !

ASSEMBLE
	Vfield  IntTable,DirVar
RPL
ASSEMBLE
	CON(5)	=DOHSTR
	REL(5)  endCode
	INCLUDE	include/entries.a
RPL

DEFINE	Param@	LastBut3
DEFINE	Param!	LastBut3 REPLACE DROP

*
* Main code entry
*
NAMELESS _Main
  ::

    { 
      MINUSONE   { { "launch" :: ZERO Main ; } }
      StndVar
      StndEntry
      StndExit
    } BinLookup case EVAL

    DROP			( Theoreticaly we could analyze it... )
     				( Default handler for the aplet )
*  ( # may be:	ApLet entered by:	)
*  ( ZERO	plot view		)
*  ( ONE	plot setup view		)
*  ( TWO	numeric view		)
*  ( THREE	numeric setup view	)
*  ( FOUR	symbolic view		)
*  ( FIVE	symbolic. setup view	)
*  ( SIX	note view		)
*  ( SEVEN	sketch view		)

** For each view, the main code is supposed to return 8 arguments (similar to the HP48/49 ParOuterLoop):
** Level: 8: View Entry handler (program)
**        7: View Exit handler (program)
**        6: Display handler (program)
**        5: Hard Key handler (program)
**        4: Flag to allow normal keys (TRUE or FALSE)
**        3: Menu Definition (list)
**        2: Initial Menu Page (System Binary)  
**        1: Error handler (program)
*<SOURCE CODE END>

    ( Note for all following quoted objects: as	)
    ( they grow further, it suggested to move	)
    ( them to become [named] INT_xx objects.	)

     ' Entry			( view entry )

     ' Exit			( view exit )

     ' Disp			( view display )

     ' 				( view hard key handlers )
     ::
       {
        NULL{}
	NULL{}
	NULL{}
	NULL{}
	NULL{}
	NULL{}
       }
       ONE KeyFace
     ;

    TRUE				( **Allow normal keys** )

    MainMenu
    
    ONE 				( **Initial menu page** )

    '					( **Error object** )
    ::	TURNMENUON RECLAIMDISP		( Ensure AGROB to be displayed when an error occurs )
	ERRJMP
    ;
  ;

DEFINE	loginchat!	TopicVar1!
DEFINE	loginchat@	TopicVar1@
DEFINE	debug!	TopicVar2!
DEFINE	debug@	TopicVar2@
DEFINE	login!	TopicVar3!
DEFINE	login@	TopicVar3@
DEFINE	pass!	TopicVar4!
DEFINE	pass@	TopicVar4@
DEFINE	modem!	TopicVar5!
DEFINE	modem@	TopicVar5@
DEFINE	tel!	TopicVar6!
DEFINE	tel@	TopicVar6@

DEFINE	default_params FALSE FALSE $ "yourlogin" $ "yourpass" $ "ATZ" $ "0123456789"
DEFINE	default_param { NULL{} default_params }

NAMELESS _Entry
::
 Param@ CDRCOMP INNERCOMP SIX #- NDROP tel! modem! pass! login! debug! loginchat!
;

NAMELESS _Exit
::
  ( store back parameters )
  Param@ CARCOMP loginchat@ debug@ login@ pass@ modem@ tel@ SEVEN {}N Param!
  ( Ensure the screen is correctly configured when exiting )
  LeaveGraphView
;

NAMELESS _Disp
::
  DA3OK?NOTIT ?DispMenu		( Redraw menu if not ok )
  DA1OK? ?SEMI
  HARDBUFF
  ZEROZERO BINT_131d SIXTYFOUR GROB!ZERODRP
  NULL$ DUPDUP
  $ "      Usinagaz"
  NULL$ DUPDUP
  SEVEN ZERO
  DO
   FOUR EIGHT INDEX@ #*
   Put5x7
  LOOP
  SetDA1Valid
;

NAMELESS _MainMenu
{
 { "ON" :: TakeOver On ; }
 { "OFF" :: TakeOver Off ; }
 { "IDLE" :: TakeOver Idle ; }
 { "SETUP" :: TakeOver Setup ; }
}

NAMELESS _Setup
::

 $ "auth......." COL1 LROW1
 $ "debug" COL12 LROW1
 $ "initstr.."  COL1 LROW3
 $ "tel........."  COL1 LROW4

* msg        x     y     w        h        type            legal          dec      hlp123456789012345678901234567  ChDat                 ChDec        res     init
 ' DROPFALSE COL6  FROW1 FWIDTH5  FHEIGHT1 FTYPE_FIXEDLIST OBTYPE_NA FMT_NONE $ "authentication method"       { $ "login" $ "PAP" } FMT_NONE     $ "PAP" loginchat@ ITE $ "login" $ "PAP"
 ' DROPFALSE COL16 FROW1 FWIDTH1  FHEIGHT1 FTYPE_CHECK     OBTYPE_NA FMT_NONE $ "show debugging messages?"    OPTDATA_NULL          OPTDATA_NULL FALSE   debug@
 ' DROPFALSE COL1  FROW2 FWIDTH10 FHEIGHT1 FTYPE_TEXT      OBTYPE_NA FMT_NONE $ "your login"                  OPTDATA_NULL          OPTDATA_NULL NULL$   login@
 ' DROPFALSE COL12 FROW2 FWIDTH10 FHEIGHT1 FTYPE_TEXT      OBTYPE_NA FMT_NONE $ "your password"               OPTDATA_NULL          OPTDATA_NULL NULL$   pass@
 ' DROPFALSE COL6  FROW3 FWIDTH16 FHEIGHT1 FTYPE_TEXT      OBTYPE_NA FMT_NONE $ "modem initialisation string" OPTDATA_NULL          OPTDATA_NULL $ "ATZ" modem@
 ' DROPFALSE COL6  FROW4 FWIDTH16 FHEIGHT1 FTYPE_TEXT      OBTYPE_NA FMT_NONE $ "telephone number"            OPTDATA_NULL          OPTDATA_NULL NULL$   tel@
 FOUR SIX
 ' DROPFALSE
 $ "Usinagaz Setup"
 DoInputForm IT :: tel! modem! pass! login! debug! CAR$ CHR># #6C #= loginchat! ;
;

* external references to Usinagaz

EXTERNAL	xCHAT
EXTERNAL	xPPPON
EXTERNAL	xPPPOFF
EXTERNAL	xIDLE

ASSEMBLE
~xCHAT		EQU	(ROMID#)+4096*0
~xPPPON		EQU	(ROMID#)+4096*1
~xPPPOFF	EQU	(ROMID#)+4096*2
~xIDLE		EQU	(ROMID#)+4096*3
	INCLUDE	include/st.a
RPL

NAMELESS _On
::
  ::
    tel@ NULL$? ?SEMI
    _b_fl_Verbose debug@ ITE SetUserFlag ClrUserFlag
    ""
    modem@ CHR ^M >T$ CHR ^J >T$
    "OK"
    "ATDT" tel@ &$ CHR ^M >T$ CHR ^J >T$
    loginchat@
    ITE
    ::
      "ogin" login@ CHR ^M >T$ CHR ^J >T$
      "assw" pass@ CHR ^M >T$ CHR ^J >T$
      EIGHT {}N
    ;
    ::
      "CONNECT"
      FIVE {}N
    ;
    xCHAT
  ;
  ::
    loginchat@ ?SEMI
    login@ pass@
  ;
  xPPPON
  loginchat@ ?SEMI
  2DROP
;

NAMELESS _Off
:: xPPPOFF ;

NAMELESS _Idle
:: xIDLE ;

ASSEMBLE
endCode
RPL


ASSEMBLE
	Vfield DirVar,DirCode
RPL
  default_param

ASSEMBLE
	Vfield DirCode,DirAlt
RPL
  { }

ASSEMBLE
	Vfield DirAlt,DirNot
RPL
  $ "by Samuel Thibault\nsamuel.thibault@ens-lyon.org\nThis is GPL software\nsee\nhttp://youpibouh.thefreecat.org/info/prog/4xinet.html\nfor more information"

ASSEMBLE
	Vfield DirNot,DirEnd
RPL
  { }
