*
* Usinagaz for hp4x
*  Copyright (C) 2000-2005 Samuel Thibault <samuel.thibault@ens-lyon.org>
*
* This program is free software ; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation ; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY ; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with the program ; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* close.s
*
* v0.4 06/05/05
*
* option functions
*
* UGETOPT expects an option number and returns its content.
*

ASSEMBLE
	CON(1)		8
RPL
xNAME UGETOPT
:: CK1&Dispatch
  #B ::
ASSEMBLE
	IFDEF	__HP4X__
RPL
    HXS>#
ASSEMBLE
	ELSE
RPL
    CODE
    GOTOL	=myHXS>#
    ENDCODE
ASSEMBLE
	ENDIF
RPL

NULLNAME getopt
::
  Rclpar
CODE
	GOSUBL	=saveregs
	GOSBVL	=GETPTR
	GOSBVL	=POP#			option # in A[A]

	GOSUB	=Asm_GETOPT
	GOC	+

	B=A	W
	A=R4.F	A
	LC(5)	(sizeblank)+((hexstrIP)-(InitializedUpar))
	A+C	A
	D0=A
	D0+	2*(SIZE_PTR)

	C=B	W
	DAT0=C	W

	GOSBVL	=GETPTR			A not modified
	DAT1=A	A			REPL option number
	GOVLNG	=PushTLoop

+
	GOTOL	myGPDropPushCFLoop
ENDCODE
;
    ?SEMI ERRORSTO ERRJMP
  ;
;

ASSEMBLE
**
**
** Asm_UGETOPT
**
** In:  A[A] holds option number.
** Out: A[W] holds the option content.
**      Carry set if an error occured, whose number will then be in C[A]
**
**

=Asm_GETOPT
	GOSUB	get_option_addr
	RTNC

	A=0	W
	C=-C	P
	P=C	0
-
	ASL	W
	ASL	W
	A=DAT0	B
	D0+	SIZE_BYTE
	P+1
	GONC	-
	RTNCC
RPL

*
* USETOPT expects an option number (level 1) and its content (level 2).
*

ASSEMBLE
	CON(1)		8
RPL
xNAME USETOPT
:: CK1&Dispatch
  #BB ::
ASSEMBLE
	IFDEF	__HP4X__
RPL
    HXS>#
ASSEMBLE
	ELSE
RPL
    CODE
    GOTOL	=myHXS>#
    ENDCODE
ASSEMBLE
	ENDIF
RPL

NULLNAME setopt
::
  Rclpar
CODE
	GOSUBL	=saveregs
	GOSBVL	=GETPTR
	GOSBVL	=POP#				option number in A[A]
	C=DAT1	A
	CD1EX
	RSTK=C
	D1+	2*(SIZE_PTR)			skip header
	C=DAT1	W
	R0=C.F	W				option content
	C=RSTK
	D1=C
	D1+	SIZE_PTR
	D+1	A				DROP option
	GOSBVL	=SAVPTR

	C=R0.F	W
	D=C	W

	GOSUB	=Asm_SETOPT
	GOC	+

	GOVLNG	=GPPushTLoop
+
	GOTOL	myGPPushCFLoop
ENDCODE
;
    ?SEMI ERRORSTO ERRJMP
  ;
;

ASSEMBLE
**
**
** Asm_USETOPT
**
** In:  A[A] holds option number. D[W] holds the option content.
**      Carry set if an error occured, whose number will then be in C[A]
**
**

=Asm_SETOPT
	GOSUB	get_option_addr
	RTNC

	A=D0
	A+C	A
	A+C	A
	D0=A
	A=0	P
	C=A-C	P
	P=C	0

	C=D	W
-
	D0-	SIZE_BYTE
	DAT0=C	B
	CSR	W
	CSR	W
	P+1
	GONC	-
	RTNCC


*
* get A[5] option's address in D0 and size in C[A] in bytes
*

-
	LC(5)	XErr_BadArgVal
	RTNSC
get_option_addr
	LC(5)	Asm_UOPT_LAST
	?A>C	A
	GOYES	-

	GOSUB	+
	CON(5)	(sizeblank)+((AdresseIP_packet)-(InitializedUpar))
	CON(5)	remoteip
	CON(5)	remotenbdns
	CON(5)	(sizeblank)+((IPDns1_packet)-(InitializedUpar))
	CON(5)	(sizeblank)+((IPDns2_packet)-(InitializedUpar))
	CON(5)	paplnlogin
	CON(5)	paplnpasswd
+
	B=A	A
	B+B	A
	B+B	A				* 5
	B+A	A
	C=RSTK
	C+B	A
	D0=C
	C=DAT0	A				get offset to read
	B=C	A
	C=R4.F	A
	C+B	A
	D0=C

	LC(1)	Asm_UOPT_NBDNS
	?C#A	P
	GOYES	+
	LC(5)	(SIZE_BYTE)/(SIZE_BYTE)		read one byte
	RTNCC
+
	LC(1)	Asm_UOPT_LOGIN
	?C#A	P
	GOYES	+
-
	C=DAT0	A
	D0+	(paplogin)-(paplnlogin)
	RTNCC
+
	LC(1)	Asm_UOPT_PASSWD
	?C=A	P
	GOYES	-

	LC(5)	(SIZE_IP)/(SIZE_BYTE)
	RTNCC
RPL
