*
* Usinagaz for hp4x
*  Copyright (C) 2000-2005 Samuel Thibault <samuel.thibault@ens-lyon.org>
*
* This program is free software ; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation ; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY ; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with the program ; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* resolv.s
*
* v0.3 01/10/02
*
* resolves domain names into IP addresses
*

ASSEMBLE
	INCLUDE include/resolv.a
	INCLUDE lib/name.a
RPL

ASSEMBLE
	CON(1)		8
RPL
xNAME RESOLV
::
  CK1&Dispatch
  real xR>B
  hxs  NOP
  str  ::

NULLNAME resolv
::
  Rclpar
CODE
	GOSUBL	=saveregs
	GOSBVL	=GETPTR

	A=DAT1	A
	D0=A
	D0+	SIZE_PTR		on size
	C=DAT0	A
	C-CON	A,SIZE_PTR
	D=C	A
	D0+	SIZE_PTR		on data

	GOSUB	=Asm_RESOLV
	GOC	+

	A=R4.F	A
	LC(5)	(sizeblank)+((hexstrIP)-(InitializedUpar))
	A+C	A
	D0=A
	D0+	2*(SIZE_PTR)

	C=B	W
	DAT0=C	SIZE_IP

	GOSBVL	=GETPTR
	DAT1=A	A			replace string by ip
	GOVLNG	=PushTLoop
+
	GOTOL	myGPDropPushCFLoop
ENDCODE
;
    ?SEMI ERRORSTO ERRJMP
  ;
;

ASSEMBLE
**
** Asm_RESOLV
**
** In:  D0 points on the hostname
**      D holds string's size in nibbles
**
** Out: B[8] holds the wanted IP (hopefully)
**      Carry is set on error, and C[A] holds the error number
**
=Asm_RESOLV
* save arguments
	A=R4.F	A
	LC(5)	dnsstr
	C+A	A
	D1=C

	AD0EX
	DAT1=A	A

	D1+	(dnslen)-(dnsstr)
	C=D	A
	DAT1=C	A

* first check this is more than just 10.11.12.13 (and in the meanwhile, compute
* possible direct IP address.
	D0=A
	P=	(SIZE_IP)-1
	B=0	WP			IP=0 at first
	DSRB.F	A			D in bytes
-
	P=	0
	D-1	A
	GOC	++
	A=DAT0	B
	D0+	SIZE_BYTE
	LC(2)	'.'
	?A=C	B
	GOYES	+
	LC(2)	'0'
	A-C	B
	GOC	toResolvname
	LC(2)	9
	?A>C	B
	GOYES	toResolvname
* digit : multiply B[B] by 10, then add A. no carry should happen
	B+B	B
	GOC	toResolvname
	C=B	B
	C+C	B
	GOC	toResolvname
	C+C	B
	GOC	toResolvname
	B+C	B
	GOC	toResolvname
	B+A	B
	GOC	toResolvname
	JUMP	-

* dot : multiply by 256, but 4th byte must be 0
+
	P=	5
	C=0	WP
	P=	6
	LC(2)	#FF
	P=	(SIZE_IP)-1
	C&B	WP
	?C#0	WP
	GOYES	toResolvname
	BSL	WP
	BSL	WP
	JUMP	-

toResolvname
	JUMP	resolvname
++
* end of name : we should have an ip, ie u.v.w.x with u!=0
	P=	5
	C=0	WP
	P=	6
	LC(2)	#FF
	P=	(SIZE_IP)-1
	C&B	WP
	?C=0	WP
	GOYES	+
	P=	0
	RTNCC

+
* but might be 0, ie remote host
	?B#0	WP
	GOYES	resolvname
	P=	0
	A=R4.F	A
	LC(5)	remoteip
	C+A	A
	D0=C
	A=DAT0	SIZE_IP

* "mirrors" the IP in A, then returns
resolvMirrorIP
	P=	16-(SIZE_IP)/(SIZE_BYTE)
-
	BSL	WP			works since P always >= 7
	BSL	WP
	B=A	B
	ASR	WP
	ASR	WP
	P+1
	GONC	-
	RTNCC

* no, this is not an ip, try to resolve this.
resolvname
	P=	0
	D1+	(dnsret)-(dnslen)

	C=RSTK				save one stack level, so as to call
	DAT1=C	A			USOCKET & co nicely

	D1+	(dnstimeout)-(dnsret)
	LC(1)	4			4 tries
	DAT1=C	B

* first get a UDP socket
:BigResolvLoop
	A=0	P
	GOSUBL	=Asm_SOCKET
	GONC	+
	GOTO	ResolvErr
+
	B=A	A
NextDNS
	A=R4.F	A
	LC(5)	dnssock
	C+A	A
	D0=C

* save its number, and connect it to the wanted server
	A=B	A
	DAT0=A	A

	D0+	(dnstimeout)-(dnssock)
	C=DAT0	B
	C-1	P
	GONC	+
	LC(5)	XErr_Time
	GOTO	ResolvErr
+
	DAT0=C	B

	?CBIT=0	1			if 3rd or 4th try, try second servr
	GOYES	+
	LC(5)	(sizeblank)+((IPDns1_packet)-(InitializedUpar))
	JUMP	++
+
	LC(5)	(sizeblank)+((IPDns2_packet)-(InitializedUpar))
++
	A=R4.F	A
	C+A	A
	D0=C
+
	P=	16-(SIZE_IP)/(SIZE_BYTE)
	C=0	W
-
	CSL	WP
	CSL	WP
	C=DAT0	B
	D0+	SIZE_BYTE
	P+1
	GONC	-

	?C=0	W
	GOYES	NextDNS

	A=B	A			socket number
	B=C	W
	LC(5)	53			domain port
	D=C	A

	GOSUBL	=Asm_CONNECT
	GONC	+
	GOTO	ResolvErr
+

* first get some room
	A=R4.F	A
	LC(5)	dnslen
	C+A	A
	D0=C
	A=DAT0	A

* Good, just have to write question now

* (qname uses one byte more, since dots separate names, while #chars precedes them)
*                   identifier +  flags    + questions # +   qname   +     #0    +   QTYPE   +   QCLASS
	LC(5)	(SIZE_WORD)+(SIZE_WORD)+4*(SIZE_WORD)+(SIZE_BYTE)+(SIZE_BYTE)+(SIZE_WORD)+(SIZE_WORD)


	C+A	A			size of our buffer

	R1=C.F	A			save it, for future WRITE

*	GOSBVL	=GETTEMP
*	ST=0	10			!! GETTEMP modifies it !!
* really bad thing !
* but we really know it isn't used, since SOCKET was done
	A=R4.F	A
	LC(5)	offsetbufsock
	C+A	A
	D0=C

	CD0EX
	R2=C.F	A			save address of buffer
	D0=C

	D1=(5)	=CRC

* identifier

	A=DAT1	A
	DAT0=A	A
	D0+	SIZE_WORD
	B=A	A

	A=R4.F	A
	LC(5)	dnsquery
	A+C	A
	D1=A

* records it
	A=B	A
	DAT1=A	A


* flags
	LC(4)	1			standard query, recursive please, beware
					of endians !
	DAT0=C	A
	D0=D0+	SIZE_WORD

* number of questions, answers, authority record, additional record.

* 1 question
	LC(4)	#100			big endian !
	DAT0=C	A
	D0=D0+	SIZE_WORD

* nothing else !
	C=0	W
	DAT0=C	(SIZE_DWORD)+(SIZE_WORD)
	D0=D0+	(SIZE_DWORD)+(SIZE_WORD)

	A=R4.F	A
	LC(5)	dnsstr
	C+A	A
	D1=C
	A=DAT1	A
	D1+	(dnslen)-(dnsstr)
	C=DAT1	A
	D=C	A			size of string (nibbles)

	D1=A				@ of string

* the QNAME
	GOSUB	=name

	C=0	B
	DAT0=C	B			final #0
	D0=D0+	SIZE_BYTE

* and the TYPE and CLASS of QNAME
	LC(4)	_dns_TYPE_A
	DAT0=C	A
	D0=D0+	SIZE_WORD

	LC(4)	_dns_CLASS_IN
	DAT0=C	SIZE_WORD

* now send it !
	A=R4.F	A
	LC(5)	dnssock
	C+A	A
	D0=C

	A=DAT0	A

	C=R2.F	A
	D0=C					address of query
	C=R1.F	A				size
	D=C	A

	GOSUBL	=Asm_WRITE			and send !
	GONC	+
	GOTO	ResolvErr
+
-
	A=R4.F	A
	LC(5)	dnssock
	C+A	A
	D0=C

	A=DAT0	A
	B=A	A
	A=0	A

	GOSUBL	=Asm_READ
	GONC	+
	GOTO	BigResolvLoop		on read error, try again (maybe unreachable)
+
	?D#0	A			size (nibbles)
	GOYES	+

	GOTO	BigResolvLoop		try again
+
	D1=A				on data

	A=R4.F	A
	LC(5)	dnsquery
	A=A+C	A
	D0=A

* first ID
	A=DAT0	A
	C=A	A
	C=DAT1	SIZE_WORD
	D1+	SIZE_WORD
	D=D-CON	A,SIZE_WORD
	GOC	-

	?A#C	A
	GOYES	-

*      0  1 2  3 4  5  6  7
* then QR|Opcode(4)|AA|RC|RD
	C=DAT1	SIZE_BYTE
	D1+	SIZE_BYTE
	D-CON	A,SIZE_BYTE
	GONC	+
	GOTO	resolverr
+

* really an answer ?
	?CBIT=1	_b_dns_QR
	GOYES	+
	GOTO	resolverr
+

* RA | Z(3) | RCODE(4)
	C=DAT1	SIZE_BYTE
	D1=D1+	SIZE_BYTE
	D=D-CON	A,SIZE_BYTE
	GONC	+
	GOTO	resolverr
+
	?C=0	P
	GOYES	++

	C-1	P
	GONC	+
	LC(5)	XErr_ResolvFormat
	GOTO	ResolvErr
+
	C-1	P
	GONC	+
	GOTO	resolverr
+
	C-1	P
	GOC	+
	GOTO	resolverr
+
	LC(5)	XErr_ResolvNotF
	GOTO	ResolvErr

++
* number of questions
	GOSUB	read16D1C

	R0=C.F	A

* number of answers
	GOSUB	read16D1C

	R1=C.F	A

* number of authority records
	GOSUB	read16D1C

* not used: too far away
*	R2=C.F	A

* number of additional records
	GOSUB	read16D1C

* not used

* first skip questions
	C=R0.F	A
	B=C	A
	C=0	A
:Questions
	B-1	A
	GOC	Answers
-
	C=DAT1	B
	D1=D1+	SIZE_BYTE
	D=D-CON	A,SIZE_BYTE
	GOC	resolverr

	?C=0	B		end ?
	GOYES	QuestTYPE

	LA(2)	_dns_max_name
	?C<=A	B
	GOYES	+

* name compression, skip
	D1=D1+	SIZE_BYTE
	D=D-CON	A,SIZE_BYTE
	GOC	resolverr
	JUMP	QuestTYPE

+
	C+C	B		-> nibbles
	AD1EX	A
	A+C	A
	D-C	A
	GOC	resolverr
	D1=A

	JUMP	-

:QuestTYPE			and class
	D1=D1+	SIZE_DWORD
	D=D-CON	A,SIZE_DWORD
	GONC	Questions

:resolverr
	LC(5)	XErr_Resolv
:ResolvErr
	D=C	A
	A=R4.F	A
	LC(5)	dnsret
	C+A	A
	D0=C
	C=DAT0	A
	RSTK=C
	C=D	A
	RTNSC


:Answers
	ST=0	_b_st_LOCAL
	C=R1.F	A
	B=C	A
	C=0	A
:Answer
	B-1	A
*	GOC	Authorities		Authorities is too far away ;-)
	GONC	+
:ResolvNotFound
	LC(5)	XErr_ResolvNotF
	JUMP	ResolvErr

+
* first skip name
-
	C=DAT1	B
	D1=D1+	SIZE_BYTE
	D=D-CON	A,SIZE_BYTE
	GOC	resolverr

	?C=0	B		end ?
	GOYES	AnswTYPE

	LA(2)	_dns_max_name
	?C<=A	B
	GOYES	+

* name compression, skip
	D1=D1+	SIZE_BYTE
	D-CON	A,SIZE_BYTE
	GOC	resolverr
	JUMP	AnswTYPE

+
	C+C	B		-> nibbles
	AD1EX	A
	A+C	A
	D-C	A
	GOC	resolverr
	D1=A
	JUMP	-

:AnswTYPE
* Type
	A=DAT1	A			only 4 used
	D1+	SIZE_WORD		skip type
	D=D-CON	A,SIZE_WORD
	GOC	resolverr2

	C=A	A
	LC(4)	_dns_TYPE_A
	?C#A	A
	GOYES	+
	ST=1	_b_st_LOCAL		kewl, we found it !
* Class
+
	A=DAT1	A			only 4 used
	D1+	SIZE_WORD		skip class
	D=D-CON	A,SIZE_WORD
	GOC	resolverr2

	C=A	A
	LC(4)	_dns_CLASS_IN
	?C#A	B
	GOYES	resolverr2

	D-CON	A,(SIZE_DWORD)+(SIZE_WORD)	count ttl & rdlength
	GOC	resolverr2

	D1+	SIZE_DWORD		skip ttl
	A=0	XS
	A=DAT1	SIZE_BYTE
	ASL	A
	ASL	A
	D1+	SIZE_BYTE
	A=DAT1	SIZE_BYTE
	D1+	SIZE_BYTE
	A+A	A	->nibbles

	?ST=1	_b_st_LOCAL
	GOYES	resolvIP

	CD1EX
	C+A	A
	D1=C
	C=A	A
	D-C	A
	GOC	resolverr2
	GOTO	Answer

:resolverr2
	JUMP	resolverr

:resolvIP
	LC(5)	SIZE_DWORD
	?C#A	A
	GOYES	resolverr2

	D-CON	A,SIZE_DWORD
	GOC	resolverr2

* here we are !
* let's note this adress down

	P=	16-(SIZE_DWORD)/(SIZE_BYTE)

-
	CSL	WP
	CSL	WP
	C=DAT1	B
	D1+	SIZE_BYTE
	P+1
	GONC	-

	B=C	W			here it is !!

	A=R4.F	A
	LC(5)	dnsret
	C+A	A
	D0=C
	C=DAT0	A
	RSTK=C
	RTNCC				ouf! At last we got it !



:read16D1C
	D=D-CON	A,SIZE_WORD
	GONC	+
	C=RSTK
	JUMP	resolverr2

+
	C=0	A
	C=DAT1	SIZE_BYTE
	D1=D1+	SIZE_BYTE
	CSL	A
	CSL	A
	C=DAT1	SIZE_BYTE
	D1=D1+	SIZE_BYTE
	RTNCC
RPL
