*
* Usinagaz for hp4x
*  Copyright (C) 2000-2005 Samuel Thibault <samuel.thibault@ens-lyon.org>
*
* This program is free software ; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation ; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY ; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with the program ; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* connx.s
*
* v0.21 01/08/02
*
* handles socket connections
* expects socket number, dest ip addr, dest port (all hex strings)
*

ASSEMBLE
	CON(1)		8
RPL
xNAME UCONNECT
:: CK3&Dispatch #1FBB
  ::
ASSEMBLE
	IFDEF	__HP4X__
RPL
  HXS>#
ASSEMBLE
	ELSE
RPL
  CODE
  GOTOL	=myHXS>#
  ENDCODE
ASSEMBLE
	ENDIF
RPL

NULLNAME connect
::
  ROT Rclpar
CODE
	GOSUBL	=saveregs
	GOSBVL	=GETPTR
	GOSBVL	=POP2#				level 1 in C[A], 2 in A[A]
	R0=C.F	A				socket number
	R1=A.F	A				port number
	C=DAT1	A
	CD1EX
	D1+	2*(SIZE_PTR)			skip header
	A=DAT1	SIZE_IP				IP
	D1=C
	D1+	SIZE_PTR
	D+1	A				DROP IP
	GOSBVL	=SAVPTR

	B=A	W				IP

	A=R0.F	A				socket number
	C=R1.F	A
	D=C	A
	GOSUB	=Asm_CONNECT
	GOC	+

	GOVLNG	=GPPushTLoop
+
	GOTOL	myGPPushCFLoop
ENDCODE
;
    ?SEMI ERRORSTO ERRJMP
  ;
;


**
**
** Asm_UCONNECT
**
**
** In:  A[A] holds socket number, always 0 for now, but please don't rely on it !
**      D[A] holds target port number
**      B[8] holds target IP address
**
** Out: carry is set if an error occured, C then holds the error number
**
**
**
** XXX: even if already connected, erases IP & port !
**
**

ASSEMBLE
=Asm_CONNECT
	GOSUBL	=ckAis0
	RTNC
	GOSUBL	=ckDisPort
	RTNC
	GOSUBL	=ckpppisconn
	RTNC

* dest port in D
	A=R4.F	A
	LC(5)	(socketports)+(SIZE_WORD)+(SIZE_BYTE)		on (Be) lo
	A=A+C	A
	D0=A

	C=D	A
	DAT0=C	B
	D0-	SIZE_BYTE
	CSR	A
	CSR	X
	DAT0=C	B

	D0+	(socketipaddr)-((socketports)+(SIZE_WORD))

* IP address in B[8]
* this loop works since P is always >= 7 !
	P=	16-((SIZE_IP)/(SIZE_BYTE))
	C=0	WP			this actually zeroes the hi part of C
-
	CSL	WP
	CSL	WP
	C=B	B
	BSR	WP
	BSR	WP
	P+1
	GONC	-


* IP #0 means "remote host"
	?C#0	W
	GOYES	+

	D0-	(socketipaddr)-(remoteip)
	C=DAT0	SIZE_IP
	D0+	(socketipaddr)-(remoteip)
+
	DAT0=C	SIZE_IP

* if tcp, we must connect ourself to the host
	D0+	(socketconnection)-(socketipaddr)
	A=DAT0	B

	LC(2)	#01			tcp, not connected
	?A#C	B
	GOYES	++

	GOTOL	=tcpconnect




++
	?A=C	P			TCP ?
	GOYES	+
	RTNCC

+
	LC(5)	XErr_AlConn		already connected !
	RTNSC




	CON(1)		8
RPL
xNAME UCLOSE
tNAME xUCLOSE UDISCONNECT		( for compatibility )
:: CK1&Dispatch
  #1F ::

NULLNAME close
::
  Rclpar
CODE
	GOSUBL	=saveregs
	GOSBVL	=GETPTR
	GOSBVL	=POP#			in A[A]
	GOSBVL	=SAVPTR

	GOSUB	=Asm_CLOSE
	GOC	+

	GOVLNG	=GPPushTLoop
+
	GOTOL	myGPPushCFLoop
ENDCODE
;
    ?SEMI ERRORSTO ERRJMP
  ;
;

ASSEMBLE
**
**
** Asm_UCLOSE
**
** In:  A[A] holds socket number, 0 for now, but please don't rely on this !
**
** Out: cary set if an error occured, whose number will then be in C[A]
**
**

=Asm_CLOSE
	GOSUBL	=ckAis0
	RTNC
	GOSUBL	=ckpppisconn
	RTNC

	A=R4.F	A
	LC(5)	socketconnection
	A=A+C	A
	D0=A				record of socket
	A=DAT0	B

	LC(2)	#11			connected TCP
	?A#C	B
	GOYES	+

	LC(2)	#01			disconnected TCP
	DAT0=C	B

	GOTOL	=tcpdisconnect

+
	?A#C	P
	GOYES	+
	LC(5)	XErr_AlDisconn
	RTNSC
+
	RTNCC
RPL
