*
* Usinagaz for hp4x
*  Copyright (C) 2000-2005 Samuel Thibault <samuel.thibault@ens-lyon.org>
*
* This program is free software ; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation ; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY ; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with the program ; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* read.s
*
* v0.3 26/02/03
*
* user command for reading data from the socket
*
* first fetch data.
* look whether some acceptable data is available. If so, pushes it
* else, if non block, timeout
*       else tick & timeout if needed
*
* TODO: check userbuffen is always 0, excepted when it must be 1
* since a WarmStart may get rid of tempob, hence losing the buffer !!
*

ASSEMBLE
	CON(1)		8
RPL
xNAME UREAD
:: CK1&Dispatch
  #1F ::

NULLNAME read
::
  Rclpar
CODE
	GOSUBL	=saveregs
	GOSBVL	=GETPTR
	GOSBVL	=POP#			socket # in A[A]

	B=A	A
	A=0	A

	GOSUB	=Asm_READ
	GOC	+

	?D=0	A
	GOYES	nullstring

* make it a string
	A-CON	A,2*(SIZE_PTR)

	D1=A
	LC(5)	=DOCSTR
	DAT1=C	A
	D1+	5
	D+CON	A,SIZE_PTR
	C=D	A
	DAT1=C	A

	GOSBVL	=GETPTR			A not modified

	DAT1=A	A			REPL socket number
	GOVLNG	=PushTLoop

nullstring
	GOSBVL	=GETPTR
	LC(5)	=NULL$
	DAT1=C	A
	GOVLNG	=PushTLoop

+
	GOTOL	myGPDropPushCFLoop
ENDCODE
;
    ?SEMI ERRORSTO ERRJMP
  ;
;

ASSEMBLE
**
**
** Asm_UREAD
**
**
** In:  A[A] holds the address of the caller's buffer, or 00000 if none used
**      D[A] holds the buffer's size, if some used, in nibbles (hence must be
**           even)
**      B[A] holds the socket number
**
** Out: A[A] holds the address of the read string
**           undefined if A[A] was != 0 or if D[A]==0
**      D[A] holds its size in nibbles (hence even), if CR/LF parsed line or UDP
**           packet overflew the buffer, the real size is returned
**      carry set if an error occured
**
**
** Hence two ways to call: (provided D0 points to the Asm_CALLS array, and
** R0[A] holds the socket number)
**
** One may don't want to manage buffer, but simply pick out from usinagaz'
**
**	A=DAT0	A
**	R4=A.F	A			Upar's address
**	D0+	5*(iUREAD)
**	C=DAT0	A			read
**	C=R0.F	A			socket number
**	B=C	A
**
**	A=0	A			no caller's buffer
**	GOSUB	=PC=C
**	GOC	=erreur
**
**	?D=0	A
**	GOYES	nothing_in_buffer
**
**	... treat data @A[A]
**
**nothing_in_buffer
**	GOVLNG	=GETPTRLOOP
**
**
**
**
**=PC=C
**	PC=C
**=erreur
**	GOVLNG	=GPErrjmpC
**
**
**
**
** Or one may want to manage its own buffer and give its address:
**
**	A=DAT0	A
**	R4=A.F	A			Upar's address
**	D0+	5*(iUREAD)
**	C=DAT0	A
**	LA(5)	bufsize
**	D=A	A
**	A=R0.F	A			socket number
**	B=A	A
**	AD1EX				get buffer's address
**	GOSUB	=PC=C
**	GOC	=erreur
**
**	?D=0	A
**	GOYES	nothing_in_buffer
**
**       ... treat data in own own buffer
**
**nothing_in_buffer
**	GOVLNG	=GETPTRLOOP
**
**
** But be careful with your buffer size: it is announced to the remote host,
** which will expect this space to be available... so you can't shrink as
** desired, only according to what was filled.
**
**
**
** don't forget to set ST flags as needed for non blocking mode or readln
** the description of User flags is available in usinagaz.txt, you just need
** to do the flag number conversion thanks to usinagaz-asm.a, embedded in
** asm.txt
**
**
** if you are getting data from Usinagaz' buffer, don't call any Usinagaz
** function which could call rechdlc before having copied it, since if more
** data come, they will surely erase the old one.
**
**



* early initialization before entering the Readln loop
-
	GOSUBL	=ztick
	JUMP	ReadLn
*
*
*
=Asm_READ
*
*
*
	C=A	A
	A=B	A
	GOSUBL	=ckAis0
	RTNC
	GOSUBL	=ckpppisconn
	RTNC

* first record caller's buffer caracteristics (even if 00000)
	B=C	A			user's buffer's address in B[A]
	A=R4.F	A
	LC(5)	socketbufffree
	C+A	A
	D0=C

	C=D	A			user's buffer's size in D[A]
	DAT0=C	A

	D0-	(socketbufffree)-(socketuserbuff)
	C=B	A
	DAT0=C	A

	D0-	(socketuserbuff)-(socketuserbuffen)
	C=0	P
	DAT0=C	B

	D0-	(socketuserbuffen)-(sockettype)
	A=DAT0	B
	LC(1)	SOCK_STREAM
	?C#A	P
	GOYES	+			skip readln testing if not STREAM

	?ST=1	_b_st_Readln
	GOYES	-
+
	D0+	(socketrcvd)-(sockettype)
	C=DAT0	A
	?C=0	A
	GOYES	readNoData

	?B=0	A
	GOYES	readNoData		if no user buffer, no need to push

* some data already there to push
	?C>=D	A			does it entirely fills user's buffer ?
	GOYES	+

	B=C	A			drop & push everything !
	D=C	A
	GOSUB	readpush		this will clear socketrcvd

	A=R4.F	A
	LC(5)	socketrcvd
	C+A	A
	D0=C
	C=D	A
	DAT0=C	A			so set what was already received in
					user's buffer
	JUMP	readNoData
+
	C=D	A			only push buffer's capacity
	B=C	A
	JUMP	readpush

readNoData

* enable user's buffer (if any)
	A=R4.F	A
	LC(5)	socketuserbuffen
	C+A	A
	D0=C
	LC(1)	1
	DAT0=C	B

* open window, if one recorded that it should be done on next READ.
	D0-	(socketuserbuffen)-(sockettype)
	A=DAT0	B
	LC(1)	SOCK_STREAM
	?C#A	P
	GOYES	+

	D0+	(socketdoopenwin)-(sockettype)
	C=DAT0	B
	?C=0	P
	GOYES	+
	C=0	P
	DAT0=C	B
	D0-	(socketdoopenwin)-(tcpconnected)
	C=DAT0	B
	D0+	(socketdoopenwin)-(tcpconnected)
	?C=0	P			but not if not connected any more
	GOYES	+
	GOSUBL	=tcpopenwindow

+
*
* and loop until something makes us give up
*
	GOSUBL	=ztick
readloop
* look for timeout
	GOSUBL	=tick
	GONC	++

	?ST=1	_b_st_LOCAL			only keypressed
	GOYES	+

* if STREAM, recall window to peer before RTNing
	A=R4.F	A
	LC(5)	sockettype
	C+A	A
	D0=C

	A=DAT0	B
	LC(1)	SOCK_STREAM
	?C#A	P
	GOYES	+

	D0+	(socketrcvd)-(sockettype)
	C=DAT0	A
	?C#0	A
	GOYES	+

* really no data, let's poke remote host
	GOSUBL	=tcpopenwindow
+
	JUMP	readendloop

++
	ST=1	_b_st_noframe
	GOSUBL	=rechdlc

* look for error
	GONC	+
	GOTO	readError
+

* if a frame was treated, first look if another arrived
	?ST=0	_b_st_noframe		loop while frame still come
	GOYES	readloop

* first look at data
	A=R4.F	A
	LC(5)	socketrcvd
	C+A	A
	D0=C

	C=DAT0	A

	?C=0	A
	GOYES	readlookdisconn		silly to test whether buffer full if it
					is empty :o)

* if not Blocking mode, give up as soon as data arrived
	?ST=1	_b_st_Block
	GOYES	+
	GOTO	readendloop
+

* if Blocking mode, just check that buffer is not full.

	D0+	(socketuserbuff)-(socketrcvd)
	A=DAT0	A

	?A#0	A
	GOYES	+
	LA(5)	sizebufsock
	JUMP	++
+
	D0+	(socketbufffree)-(socketuserbuff)
	A=DAT0	A
++
	?C<A	A			> should never happen, but who knows :o)
	GOYES	+
	GOTO	readendloop

+
* not full, but check for disconnection
	A=R4.F	A
	LC(5)	sockettype
	C+A	A
	D0=C
	A=DAT0	B
	LC(1)	SOCK_STREAM
	?C#A	P
	GOYES	+
	D0+	(tcpconnected)-(sockettype)
	C=DAT0	B
	?C#0	P
	GOYES	+
	GOTO	readendloop
+
	JUMP	readloop

readlookdisconn
* look for disconnection
	A=R4.F	A
	LC(5)	sockettype
	C+A	A
	D0=C
	A=DAT0	B
	LC(1)	SOCK_STREAM
	?C#A	P
	GOYES	+

	D0+	(tcpconnected)-(sockettype)
	C=DAT0	B
	?C=0	P
	GOYES	readdisconn

+

* if non blocking mode, flushing incoming frame suffices
	?ST=1	_b_st_NBlock
	GOYES	readendloop

	GOTO	readloop		no timeout, buffer empty or not full,
					still connected, so loop !

readdisconn
	A=R4.F	A
	LC(5)	tcpstatus
	C+A	A
	D0=C
	A=DAT0	B
	LC(1)	_tcp_Rst
	?C=A	P
	GOYES	+
	LC(5)	XErr_Disconn
	JUMP	++
+
	LC(5)	XErr_TCPRST
++

* on error, clean socket buffer
readError
	B=C	A			save error code
	A=R4.F	A
	LC(5)	socketrcvd
	C+A	A
	D0=C

	C=0	A
	DAT0=C	A			clear all data
	D0+	(socketuserbuffen)-(socketrcvd)
	DAT0=C	B			and disable user buffer
	C=B	A
	RTNSC

* something made us give up
readendloop
	A=R4.F	A
	LC(5)	socketrcvd
	C+A	A
	D0=C

	C=DAT0	A
	D=C	A			return data size
	D0-	(socketrcvd)-(socketdoopenwin)

	?D=0	A
	GOYES	+

* some data, so remember to reopen window next time
	LC(1)	1
	DAT0=C	B
+

	D0+	(socketuserbuff)-(socketdoopenwin)
	C=DAT0	A
	?C#0	A
	GOYES	+

* Usinagaz' buffer, flush it
	C=D	A
	B=C	A
	GOTO	readpush
+
	D0-	(socketuserbuff)-(socketrcvd)
	C=0	A
	DAT0=C	A
	D0+	(socketuserbuffen)-(socketrcvd)
	DAT0=C	B
	RTNCC


*
*
*
* ReadLn processing
*
*
*

--
* no frame, no data => give up if NBlock
	?ST=0	_b_st_NBlock
	GOYES	ReadLn

readlntout
	?ST=1	_b_st_LOCAL		only keypressed
	GOYES	+
	GOSUBL	=tcpopenwindow
+
	D=0	A			no data
	RTNCC

-
	D0-	(socketrcvd)-(tcpconnected)
	C=DAT0	B
	?C#0	P
	GOYES	+
	LC(5)	XErr_Disconn
	RTNSC
+
	GOSUBL	=tick
	GOC	readlntout
	ST=1	_b_st_noframe
	GOSUBL	=rechdlc
	RTNC

	?ST=1	_b_st_noframe
	GOYES	--

:ReadLn
* first try to get data as long as packets are already here !
	A=R4.F	A
	LC(5)	socketrcvd
	C+A	A
	D0=C
	C=DAT0	A
	?C=0	A
	GOYES	-

* now there is data, we'll loop looking for CR or LF, but with a timeout
:ReadLnloop
	A=R4.F	A
	LC(5)	socketpointer
	C+A	A
	D0=C
	C=DAT0	A
	D=C	A			offset in socket buffer

	LC(5)	offsetbufsock
	C+A	A
	C+D	A			added to socket buffer address
	R2=C.F	A			R2[A] holds data address

	D1=C				D1 on data

	D0-	(socketpointer)-(socketrcvd)
	C=DAT0	A
	D=C	A
	R0=C.F	A			total data size in R0[A]
	DSRB.F	A
	LC(2)	_CR
	B=C	B
	LC(2)	_LF
	D-1	A
	GOC	+
-
	A=DAT1	B
	?A=B	B
	GOYES	foundCR
	?A=C	B
	GOYES	foundLF

	D1+	SIZE_BYTE
	D-1	A
	GONC	-

* couldn't find CR or LF => give up if NBlock

+
-
	GOSUBL	=tick
	GOC	readlntout2		if timed out, give up

	ST=1	_b_st_noframe
	GOSUBL	=rechdlc		else try to read
	RTNC

	?ST=0	_b_st_noframe
	GOYES	ReadLnloop

	A=R4.F	A
	LC(5)	tcpconnected
	C+A	A
	D0=C
	C=DAT0	B
	?C=0	P
	GOYES	++

	?ST=0	_b_st_NBlock
	GOYES	-
readlntout2
	D=0	A
	RTNCC
++
	LC(5)	XErr_Disconn
	RTNSC



foundCR
	B=C	B			B holds the other line break char
foundLF
	A=B	XS			this is intended to make the future
	?D#0	A			test fail, if no more data is available
	GOYES	+			(hence no other line break possible)
	A+1	XS	XXX	we can't afford waiting for another line break
+
	D+1	A			put line break back
	C=R0.F	A			total size
	D+D	A			size left in nibbles
	C-D	A
	D=C	A			D[A] holds data size in nibbles
	D1+	SIZE_BYTE
	A=DAT1	B
	?A#B	X
	GOYES	+
* a different line break mark, drop it too
	C+CON	A,SIZE_BYTE
+
	C+CON	A,SIZE_BYTE
	B=C	A			data to drop

*	JUMP	readpush
*XXX because just there :)

*
* readpush drops B[A] nibbles from socket's buffer, copying D[A] of them
* beforehand if a user buffer was provided
*
* returns exactly what is needed on return of Asm_READ: address of buffer and
* size copied
*
* hence D[A] is doubled
*
readpush

*
* so drop data from socket buffer
*
	A=R4.F	A
	LC(5)	socketdoopenwin
	C+A	A
	D0=C

	?B=0	A
	GOYES	+
* some data, so remember to reopen window next time
	LC(1)	1
	DAT0=C	B
+
	D0+	(socketrcvd)-(socketdoopenwin)

	C=DAT0	A
	C-B	A
	DAT0=C	A

	D0+	(socketpointer)-(socketrcvd)
	C=DAT0	A
	A=C	A
	C+B	A
	DAT0=C	A

	LC(5)	offsetbufsock
	A+C	A
	C=R4.F	A
	A+C	A			A[A] points on data

	D0+	(socketuserbuff)-(socketpointer)
	C=DAT0	A
	?C#0	A
	GOYES	++

* no caller's buffer, so simply give back @, size
	D0+	(socketuserbuffen)-(socketuserbuff)
	DAT0=C	A			who knows...

	RTNCC				D & A already set

++
* let's copy in caller's buffer and return copied data's size
	D1=C				desti

	D0+	(socketbufffree)-(socketuserbuff)
	C=DAT0	A
	?C>=D	A
	GOYES	+			truncate to caller's buffer's size
	C=D	A			size in nibbles
+
	D0=A				source
	GOVLNG	=MOVEDOWN		hehe MOVEDOWN does RTNCC and does not
					modify D :)

RPL
