*
* Usinagaz for hp4x
*  Copyright (C) 2000-2005 Samuel Thibault <samuel.thibault@ens-lyon.org>
*
* This program is free software ; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation ; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY ; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with the program ; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* socket.s
*
* v0.21 01/08/02
*
* implements Unix-like sockets
*
* SOCKET expects a real : 0 for UDP, 1 for TCP, 2 for RAW
*        gives the number of the socket (*keep* it)
*

ASSEMBLE
	CON(1)		8
RPL
xNAME USOCKET
:: CK1&Dispatch
  real :: COERCE
NULLNAME socket
::
  Rclpar
CODE
	GOSUBL	=saveregs
	GOSBVL	=GETPTR
	GOSBVL	=POP#				in A[A]
	GOSBVL	=SAVPTR

	GOSUB	=Asm_SOCKET
	GOC	+

	GOTOL	myGPPushATLoop
+
	GOTOL	myGPPushCFLoop
ENDCODE
  _b_fl_NBlock ClrUserFlag
  _b_fl_Readln ClrUserFlag
  _b_fl_Block  ClrUserFlag
;
    ?SEMI ERRORSTO ERRJMP
  ;
;

ASSEMBLE
	INCLUDE include/socket.a

**
**
** Asm_USOCKET
**
** In:  A[1] holds socket type (0 for UDP, 1 for TCP, 2 for RAW)
**
** Out: A[A] holds the socket number (always 0 for now, but you *mustn't*
**      rely on this, as it may change !
**      carry set on error, C[A] holds the error number
**
**
-
	LC(5)	XErr_BadArgVal
	RTNSC

=Asm_SOCKET
* first get socket type, check between 0 and 2, and record it
	LC(1)	SOCK_RAW
	?A>C	P
	GOYES	-
	B=A	P

	A=R4.F	A
	LC(5)	socketconnection
	A+C	A
	D0=A

	C=0	B
	C=B	P
	DAT0=C	B			and set socketconnected to 0

* create new socket : just binds it to default port
++
	D0-	(socketconnection)-(defaultport)
	A=DAT0	A			only 4 used
	P=	(SIZE_WORD)-1
	A+1	A
	P=	0
	GONC	+
	LA(5)	SOCK_fst_port
+
	DAT0=A	SIZE_WORD
	B=A	A
	BSR	A
	BSR	X			beware of endians !
	ASL	X
	ASL	A
	A=B	B

	D0+	(socketports)-(defaultport)

	DAT0=A	SIZE_WORD

* clears received data
	D0+	(socketrcvd)-(socketports)
	A=0	A
	DAT0=A	A
	D0+	(socketpointer)-(socketrcvd)
	DAT0=A	A

* A is 0
* and reset flags to default
	ST=0	_b_st_NBlock
	ST=0	_b_st_Readln
	RTNCC

RPL
	INCLUDE socket/bind.s
	INCLUDE socket/connx.s
ASSEMBLE
	INCLUDE socket/send.a
RPL
	INCLUDE socket/write.s
ASSEMBLE
	INCLUDE socket/rec.a
RPL
	INCLUDE socket/read.s
	INCLUDE socket/accept.s
