*
* Usinagaz for hp4x
*  Copyright (C) 2000-2005 Samuel Thibault <samuel.thibault@ens-lyon.org>
*
* This program is free software ; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation ; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY ; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with the program ; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* write.s
*
* v0.3 26/02/03
*
* user command for writing data on the socket
*

ASSEMBLE
	CON(1)		8
RPL
xNAME UWRITE
:: CK2&Dispatch
  #31F ::

NULLNAME write
::
  Rclpar
CODE
	GOSUBL	=saveregs
	GOSBVL	=GETPTR
	GOSBVL	=POP#			socket number in A[A]
	C=DAT1	A
	D1+	SIZE_PTR
	D+1	A			DROP string
	RSTK=C
	GOSBVL	=SAVPTR
	C=RSTK

	D0=C
	D0+	SIZE_PTR		on size
	C=DAT0	A
	C-CON	A,SIZE_PTR		substract size's size
	D0+	SIZE_PTR

	D=C	A

	GOSUB	=Asm_WRITE
	GOC	+

	GOVLNG	=GPPushTLoop
+
	GOTOL	myGPPushCFLoop
ENDCODE
;
    ?SEMI ERRORSTO ERRJMP
  ;
;

ASSEMBLE
**
**
** Asm_UWRITE
**
**
** In:  A[A] holds socket number, always 0 for now, but please don't rely on it !
**      D[A] holds string length in nibbles
**      D0   points to that string
**
** Out: carry set if an error occured, C then holds the error number
**
**

=Asm_WRITE
	GOSUBL	=ckAis0
	RTNC
	GOSUBL	=ckpppisconn
	RTNC

	C=D	A
	R0=C.F	A

* XXX don't touch D0 !

* check early whether it is a tcp socket
	A=R4.F	A
	LC(5)	sockettype
	C+A	A
	D1=C

	A=DAT1	P
	B=A	P
	LC(1)	SOCK_STREAM
	?C=A	P
	GOYES	writetcp

* not tcp : we can't split
	D1-	(sockettype)-(mtu)
	A=DAT1	A			mtu in bytes

* let's see what we will add to that string

	LC(1)	SOCK_RAW
	?B=C	P			B still holds socket type
	GOYES	+

	LC(5)	(_UDP_headersize)+(_IP_headersize)
	A=A-C	A
+
	A+A	A			mtu in nibbles
	C=R0.F	A			size to send

	?C>A	A			doesn't holds in mtu ?
	GOYES	+

	GOTO	=sendsock

+
	LC(5)	XErr_MTU
	RTNSC


-
	LC(5)	XErr_Disconn
	RTNSC

:writetcp
* check that we are still connected
	A=R4.F	A
	LC(5)	socketconnected
	A+C	A
	D1=A

	C=DAT1	P
	?C=0	P
	GOYES	-

* records size, address, etc...
	D1+	(sockettosend)-(socketconnected)

	C=R0.F	A
	CSRB.F	A			in bytes
	DAT1=C	A
	D1+	(socket@tosend)-(sockettosend)
	CD0EX	A
	DAT1=C	A
	D1+	(socketsent)-(socket@tosend)
	C=0	A
	DAT1=C	A

* sets the window at the beginning
	D1+	(tcpseq)-(socketsent)
	C=DAT1	SIZE_DWORD
	D1-	(tcpseq)-(tcpoldseq)
	DAT1=C	SIZE_DWORD		fully acked last time

	D1-	(tcpoldseq)-(sockettimeout)
	LC(1)	_num_retries
	DAT1=C	B

	GOSUBL	=ztick

:loopwritetcp
* first check that he didn't send any RST
	A=R4.F	A
	LC(5)	tcpstatus
	C+A	A
	D1=C
	A=DAT1	B
	LC(1)	_tcp_Rst
	?C#A	P
	GOYES	+
* gasp, RST, so give up data
	RTNCC				but silently
+

	A=R4.F	A
	D1=A
	D1+	mtu
	A=DAT1	A
	C=0	A
	LC(2)	(_IP_headersize)+(_TCP_headersize)
	A-C	A

	B=A	A			what we can send

	A=R4.F	A
	LC(5)	tcpwindow
	C+A	A
	D1=C
	A=DAT1	A			his window

	D1-	(tcpwindow)-(socketsent)
	C=DAT1	A
	A=A-C	A			win=hiswin-sent

	?A>=B	A
	GOYES	+

	B=A	A			it's the window which restricts data
+
	D1-	(socketsent)-(sockettosend)
	A=DAT1	A

	C=A-C	A			tosend - sent = what we need to send
	?C<=B	A			does it fit in the restriction ?
	GOYES	+
	C=B	A
+
* C contains what we will send

	?C=0	A
	GOYES	socketcantwrite

	C+C	A
	R0=C.F	A			size in nibbles in R0[A]
	CSRB.F	A

	D1+	(socketsent)-(sockettosend)
	A=DAT1	A			sent
	B=0	W					(for later use)
	B=A	A			is saved
	A=A+C	A			and
	DAT1=A	A			increased

	D1-	(socketsent)-(socket@tosend)
	C=DAT1	A

	C=C+B	A
	C=C+B	A			(! nibbles)
	D0=C

	D1+	(tcpoldseq)-(socket@tosend)
	C=DAT1	SIZE_DWORD

	P=	(SIZE_DWORD)-1
	C=C+B	WP			B=0	W used here
	P=	0

	D1+	(tcpseq)-(tcpoldseq)	seq number of these data
	DAT1=C	SIZE_DWORD

	GOSUB	=sendsock		send it !

:socketcantwrite
	A=R4.F	A
	LC(5)	(sockettosend)
	C+A	A
	D0=C

	C=DAT0	A
	?C#0	A
	GOYES	+

	D0+	(tcpoldseq)-(sockettosend)
	C=DAT0	SIZE_DWORD
	D0+	(tcpseq)-(tcpoldseq)
	DAT0=C	SIZE_DWORD
	RTNCC				finished !!!!

+
	GOSUBL	=rechdlc
	RTNC

	A=R4.F	A
	LC(5)	(tcpoldseq)
	C+A	A
	D0=C

	C=DAT0	SIZE_DWORD

	D0+	(tcpacked)-(tcpoldseq)
	A=C	W
	A=DAT0	SIZE_DWORD

	?C#A	W
	GOYES	writeshiftwin

* stalled
	GOSUBL	=tick
	GONC	++

	?ST=1	_b_st_LOCAL		only keypressed
	GOYES	+
* we waited for long ! Let's try to resend it
	A=R4.F	A
	LC(5)	socketsent
	C+A	A
	D0=C

	C=0	A
	DAT0=C	A			simply believe we didn't send anything !

	GOSUBL	=ztick
+
	A=R4.F	A
	LC(5)	sockettimeout
	C+A	A
	D0=C
	C=DAT0	B
	C-1	P
	GOC	writetimeout
	DAT0=C	B
++
	JUMP	loopwritetcp

:writetimeout
	LC(5)	XErr_Time
	RTNSC

:writeshiftwin
* data was acked, so shift the window !
	P=	(SIZE_DWORD)-1
	C=A-C	WP			new - old = window shift
	P=	0

* shift seq
	D0-	(tcpacked)-(tcpoldseq)
	DAT0=A	SIZE_DWORD		new fully acked

* shift sent
	D0-	(tcpoldseq)-(socketsent)
	A=DAT0	A
	A=A-C	A			part of sent data was acked
	DAT0=A	A

* shift @tosend
	D0-	(socketsent)-(socket@tosend)
	A=DAT0	A
	A=A+C	A
	A=A+C	A			! nibbles
	DAT0=A	A

* shift tosend
	D0-	(socket@tosend)-(sockettosend)
	A=DAT0	A
	A=A-C	A
	DAT0=A	A

	JUMP	loopwritetcp


RPL
